<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:tpl="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns:xpath="xalan://fr.in2p3.lavoisier.template.preprocess.XPathAnalyser"
                exclude-result-prefixes="xalan tpl xpath">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <xsl:template match="*">
        <xsl:variable name="depth" select="xpath:getDepth(@if | text() | @attributes | tpl:set/text() |
                                                          parent::tpl:element-create-as-parent/@attributes |
                                                          parent::tpl:element-create-as-parent/@group-by)"/>
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:if test="$depth > -1">
                <xsl:attribute name="depth">
                    <xsl:value-of select="$depth"/>
                </xsl:attribute>
            </xsl:if>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>